(*
   Quelques exemples d'utilisation de la tactique Gb.
*)
   
Require Export Gbcoq.

(* Dans R *)

Lemma lR1:(x,y:R)``x*x+2*x*y+y*y==0``->``x+y==0``.
Intros.
Time Gb.
Qed.

Lemma lR2:(x,y,a,b,c:R)``a*x*x+b*x+c==0``->``b==-a*(x+y)``->``c==a*x*y``->``a*y*y+b*y+c==0``.
Intros.
Time Gb.
Qed.

Lemma lR3:(x,y:R)``(x+y)*(x+y)==0``->``x+y==0``.
Intros.
Time Gb.
Qed.

Lemma lR4:(x,y:R)``(x+y)*(x+y)*(x+y)*(x+y)*(x+y)==0``->``x+y==0``.
Intros.
Time Gb.
Qed.

Lemma lR5:(x,y,z:R)``(x+y+z)*(x+y+z)*(x+y+z)==0``->``x+y+z==0``.
Intros.
Time Gb.
Qed.

Lemma lR6:(x,y,z,a,b,c,d:R)
    ``b==-a*(x+y+z)``->``c==a*(x*y+y*z+z*x)``->``d==-a*x*y*z``
    -> ``a*x*x*x+b*x*x+c*x+d==0``.
Intros.
Time Gb.
Qed.

(* Dans Z *)

Lemma lZ1:(x,y,a,b,c:Z)`a*x*x+b*x+c=0`->`b=-a*(x+y)`->`c=a*x*y`->`a*y*y+b*y+c=0`.
Intros.
Time Gb.
Qed.

(* Dans un anneau formel *)
Section S1.

Variable A : Type.

Variable Aplus : A -> A -> A.
Variable Amult : A -> A -> A.
Variable Aone : A.
Variable Azero : A.
Variable Aopp : A -> A.
Variable Aeq : A -> A -> bool.

Infix 4 "+" Aplus.
Infix 4 "*" Amult.
Notation "0" := Azero.
Notation "1" := Aone.
Notation "- x" := (Aopp x) (at level 3).
Variable TA:(Ring_Theory Aplus Amult Aone Azero Aopp Aeq).

Add Abstract Ring A Aplus Amult Aone Azero Aopp Aeq TA.

Hypothesis Adomain:(n,m:A)n*m==0->n==0\/m==0.
Hypothesis Aonezero: ~1==0.

Lemma lA1:(x,y,a,b,c:A)a*x*x+b*x+c==0->b==-a*(x+y)->c==a*x*y->a*y*y+b*y+c==0.
Intros.
Time Gb.
Qed.

Lemma lA2:(x,y,z,a,b,c,d:A)
    b==-a*(x+y+z)->c==a*(x*y+y*z+z*x)->d==-a*x*y*z
    -> a*x*x*x+b*x*x+c*x+d==0.
Intros.
Time Gb.
Qed.
End S1.