<TeXmacs|1.0.1.23>

<style|article>

<\body>
  <\expand|make-title>
    <title|La tactique Gb>

    <author|Loc pottier et Jrme creci>

    <address|novembre 2003>
  </expand>

  <section|Principe.>

  On veut montrer un nonc <with|mode|math|\<cal-E\>> de la forme
  <with|mode|math|P<rsub|1>=0,\<ldots\>,P<rsub|n>=0 \<Rightarrow\> P=0> , o
  <with|mode|math|P<rsub|1>,\<ldots\>,P<rsub|n>,P> sont des polynmes 
  plusieurs variables <with|mode|math|x<rsub|1>,\<ldots\>,x<rsub|m>> et 
  coefficients dans un anneau commutatif intgre
  <with|mode|math|><with|mode|math|A>.

  Le <em|Nullstellensatz>, ou thorme des zros de Hilbert nous dit que
  <with|mode|math|><with|mode|math|\<cal-E\>> est quivalent au fait qu'il
  existe un entier <with|mode|math|r> et des polynmes
  <with|mode|math|Q<rsub|1>,\<ldots\>,Q<rsub|n>> tels que
  <with|mode|math|P<rsup|r>=<big|sum><rsub|i>Q<rsub|i>P<rsub|i>><with|mode|math|>

  Pour calculer <with|mode|math|r> et les <with|mode|math|Q<rsub|i>>, on
  introduit de nouvelles variables <with|mode|math|t,
  e<rsub|0>,e<rsub|1>,\<ldots\>,e<rsub|n>,z> et les polynmes suivants:

  <\expand|equation*>
    \;

    <with|mode|math|t*(1-z*P)-e<rsub|0>>

    <with|mode|math|><with|mode|math|t*P<rsub|1>-e1>

    <with|mode|math|\<ldots\>>

    <with|mode|math|t*P<rsub|n>-e<rsub|n>>

    <with|mode|math|e<rsub|i>*e<rsub|j>>, \ pour tout
    <with|mode|math|i\<less\>j><with|mode|math|> dans <with|mode|math|[0;n]>

    t*e<rsub|i> , pour tout <with|mode|math|i><with|mode|math|> dans
    <with|mode|math|[0;n]>
  </expand>

  dont on calcule une base de Grbner avec l'ordre sur les variables suivant:\ 

  <\expand|equation*>
    <with|mode|math|t\<gg\>x<rsub|1>,\<ldots\>,x<rsub|m>\<gg\>z\<gg\>e<rsub|0>,e<rsub|1>,\<ldots\>e<rsub|n>>
  </expand>

  <with|mode|math|\<cal-E\>> est vrai si et seulement si il existe dans cette
  base de Grbner un polynme de la forme\ 

  <\expand|equation*>
    <with|mode|math|k*t-R*e<rsub|0>-R<rsub|1*>e<rsub|1>\<ldots\>
    -R<rsub|n>*e<rsub|n>>
  </expand>

  o <with|mode|math|R,R<rsub|1>,\<ldots\>,R<rsub|n>> sont des polynmes en
  <with|mode|math|z,x<rsub|1>,\<ldots\>,x<rsub|m>>, et <with|mode|math|k> un
  entier.

  L'entier <with|mode|math|r> est alors le plus grand degr en
  <with|mode|math|z> des polynmes <with|mode|math|R,R<rsub|1>,\<ldots\>,R<rsub|n>>.

  Et on a

  <\expand|equation*>
    <tabular|<tformat|<table|<row|<cell|Q<rsub|1>=P<rsup|r>*R<rsub|1>[z\<leftarrow\>P<rsup|-1>]>>|<row|<cell|\<ldots\>>>|<row|<cell|Q<rsub|n>=P<rsup|r>*R<rsub|n>[z\<leftarrow\>P<rsup|-1>]>>>>>
  </expand>

  <section|Mise en oeuvre.>

  Le calcul de la base de Grbner se fait en ocaml avec l'algorithme de
  Buchberger extrait en grande partie du code Coq crit et prouv correct par
  Laurent Thry (module <verbatim|dansideal.ml>). Le calcul arithmtique sur
  les entiers (non borns) et les polynmes est lui crit directement en
  ocaml (modules <verbatim|entiers.ml>, <verbatim|polynomes2.ml> pour la
  reprsentation rcursive, et <verbatim|dansideal.ml> pour la reprsentation
  creuse). La tactique <verbatim|Gb> elle-mme est crite dans le module
  <verbatim|gbcoq.ml>. Elle utilise quelques dfinitions et thormes sur les
  anneaux, ainsi que des tactiques auxiliaires donns dans le fichier
  <verbatim|Gbcoq.v>.

  La mthode est simple. Supposons qu'on ait un but de la forme
  <with|mode|math|a=b>, o <with|mode|math|a> et <with|mode|math|b> sont des
  termes ayant pour type un anneau <with|mode|math|A> dclar comme tel dans
  Coq (commande <verbatim|Add (Abstract) Ring>).

  <\expand|enumerate-numeric>
    <item>on commence d'abord par dtecter dans le contexte les galits dans
    <with|mode|math|A> : <with|mode|math|a<rsub|1>=b<rsub|1>,\<ldots\>,a<rsub|n>=b<rsub|n>>,
    dont on en dduit les polynmes <with|mode|math|P<rsub|1>,\<ldots\>,P<rsub|n>,P>.

    <item> on calcule <with|mode|math|r> et les
    <with|mode|math|Q<rsub|1>,\<ldots\>,Q<rsub|n>> tels que
    <with|mode|math|P<rsup|r>=<big|sum><rsub|i>Q<rsub|i>P<rsub|i>><with|mode|math|>
    (voir section 1).

    <item>On en dduit alors une preuve de
    <with|mode|math|P<rsub|1>=0,\<ldots\>,P<rsub|n>=0 \<Rightarrow\> P=0>,
    (si <with|mode|math|r\<gtr\>1>, on suppose \ que l'anneau
    <with|mode|math|A> est intgre) et enfin de <with|mode|math|a=b>, 
    l'aide des galits du contexte <with|mode|math|a<rsub|1>=b<rsub|1>,\<ldots\>,a<rsub|n>=b<rsub|n>>

    <item>reste, si <with|mode|math|r\<gtr\>1>,  montrer que
    <with|mode|math|A> est intgre.
  </expand>

  On peut voir quelques exemples dans le fichier <verbatim|Exemples.v>
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|30mm>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|page type|a4>
    <associate|reduction page bottom margin|15mm>
    <associate|even page margin|30mm>
    <associate|reduction page left margin|25mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
    <associate|language|french>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|toc-1|<tuple|1|1>>
    <associate|toc-2|<tuple|2|1>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|1<space|2spc>Principe.><value|toc-dots><pageref|toc-1><vspace|0.5fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|2<space|2spc>Mise en
      oeuvre.><value|toc-dots><pageref|toc-2><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>
